package jlenses;
//Contornos Aramini
//Motor de Calculo -MC->B<
import java.lang.*;

public class F2lentes {
int Mv=100, Nv=100, Nm=120, Nl=10, Np=10, Nd=((Nv + 1) * (Mv + 1)), BOUND2=1, WID=1, IWID=1, HEI=1, IHEI=1, HPIX=410, IHPIX=410, VPIX=410, IVPIX=410;//define
double xlow, ylow, delx, dely, v, fold[]=new double[Nv], fnew[]=new double[Nv], c_10  = -2, c_12  =   2, c_b11 =   0.0, XINC=1.0E-10, Epsilon=1.0E-20;
int c_0 = 0, c_1 = 1, c_3 = 25, c_M = Mv, c_N = Nv,mod,Nint=100,nfcall1,Number_of_roots = 4,Ne=2,Nb=200;
G4lentes G4 = new G4lentes();
static double BOUND=5,Xr[][]=new double[34][2],pars[]=new double[2],fnct1, fnct2,root_x[]=new double[500], root_y[]=new double[500], troot_x[]=new double[500], troot_y[]=new double[500];
public F2lentes(){}//Flentes
void cntr(int numx, int numy,double xmin, double xmax, double ymin, double ymax, double val[], int nvals, int nchars, double title, int gridp){
  int i_1, i_2, i_3, i_4, i_5, i, j, k, l;
  double r_1, r_2, r_3, r_4, f, x, y, chars, xxmax, yymax, x0, x1=-1, x2=1, y1=-1, y2=1, y0, height, bslope=0;

    bslope = (y2 - y1) / (x2 - x1);

    if(((ymax - ymin) * 1.125) / (xmax - xmin) < bslope) {
      xxmax = xmax;
      yymax = (xmax - xmin) * bslope + ymin - (ymax - ymin) * 0.125;
    }else{
                yymax = ymax;
            xxmax = ((ymax - ymin) * 1.125) / bslope + xmin;
    }

    r_1 = ymin - (ymax - ymin) * 0.125;

    if(nchars <= 0) {
      ;
    }else{

    chars = (double) (nchars);
    height = (xmax - xmin) / chars;

    x0 = 0.0;

    if(height <= (ymax - ymin) * 0.0625) {
      r_1 = ymin * 1.0625 - ymax * 0.0625 - height * 0.5;
      r_2 = (height * 100.0) / (yymax - ymin + (ymax - ymin) * 0.125);
    }else{
    height = (ymax - ymin) * 0.0625;
    x0 = (xmax - xmin - height * chars) * 0.5 + xmin;}
    }
    xlow = xmin;
    ylow = ymin;
    delx = (xmax - xmin) / numx;
    dely = (ymax - ymin) / numy;

    if(gridp==0) {
      ;
    }else{

    i_1 = numx;
    for(i = 1; i <= i_1;i++) {

      r_1 = xx(i);
      r_2 = yy(c_1);
      r_3 = xx(i);
      r_4 = yy(numy);

      G4.draw_line(r_1, r_2, r_3, r_4);
    }

    i_1 = numy;
    for(j = 1; j <= i_1; ++j) {

      r_1 = xx(c_1);
      r_2 = yy(j);
      r_3 = xx(numx);
      r_4 = yy(j);

      G4.draw_line(r_1, r_2, r_3, r_4);
    }}

    i_1 = numx;
    for(i = 1; i <= i_1; ++i) {

      r_1 = xx(i);
      r_2 = yy(c_1);

      fold[i - 1] = funct(r_1, r_2);
    }

    i_1 = numy;
    for(j = 2; j <= i_1; ++j) {
      r_1 = xx(c_1);
      r_2 = yy(j);

      fnew[0] = funct(r_1, r_2);

      i_2 = numx;
      for(i = 2; i <= i_2; ++i) {
        r_1 = xx(i);
        r_2 = yy(j);

        fnew[i - 1] = funct(r_1, r_2);

        i_3 = nvals;

        for(k = 1; k <= i_3; ++k) {
             v = val[k-1];

          l = 0;
          if(fold[i - 1] >= v) {
            l++;
          }

          if(fold[i - 2] >= v) {
            l = l + 2;
          }

          if(fnew[i - 1] >= v) {
            l = l + 4;
          }

          if(fnew[i - 2] >= v) {
            l = l + 8;
          }
          switch((l + 1)) {
          case 16:
          case  1:  break;
          case 15:
          case  2:  {
                r_1 = bot(i);
                  i_4 = j - 1;
                  r_2 = yy(i_4);
                  r_3 = xx(i);
                  r_4 = right(i, j);
                  G4.draw_line(r_1, r_2, r_3, r_4);
                  break;}
          case 14:
          case  3:  {
                i_4 = i - 1;
                  r_1 = xx(i_4);
                  r_2 = aleft(i, j);
                  r_3 = bot(i);
                  i_5 = j - 1;
                  r_4 = yy(i_5);
                  G4.draw_line(r_1, r_2, r_3, r_4);
                break;}
          case 13:
          case  4:  {
                i_4 = i - 1;
                r_1 = xx(i_4);
                r_2 = aleft(i, j);
                r_3 = xx(i);
                r_4 = right(i, j);
                  G4.draw_line(r_1, r_2, r_3, r_4);
                break;}
        case 12:
          case  5:  {
                r_1 = top(i);
                r_2 = yy(j);
                r_3 = xx(i);
                r_4 = right(i, j);
                G4.draw_line(r_1, r_2, r_3, r_4);
                break;}
        case 11:
          case  6:  {
                r_1 = bot(i);
                i_4 = j - 1;
                r_2 = yy(i_4);
                r_3 = top(i);
                r_4 = yy(j);
                G4.draw_line(r_1, r_2, r_3, r_4);
                break;}
          case 10:
          case  7:  {
                x0 = ainter(fold[i - 2], fold[i - 1]);
                x1 = ainter(fnew[i - 2], fnew[i - 1]);
                y0 = ainter(fold[i - 2], fnew[i - 2]);
                y1 = ainter(fold[i - 1], fnew[i - 1]);
                y = (x0 * (y1 - y0) + y0) / (1.0 - (x1 - x0) * (y1 - y0));
                x = y * (x1 - x0) + x0;
                i_4 = i - 1;
                r_1 = xx(i_4) + delx * x;
                i_5 = j - 1;
                r_2 = yy(i_5) + dely * y;
                f = funct(r_1, r_2);
                if(f == v) {
                        r_1 = bot(i);
                        i_4 = j - 1;
                        r_2 = yy(i_4);
                        r_3 = top(i);
                        r_4 = yy(j);
                        G4.draw_line(r_1, r_2, r_3, r_4);
                        i_4 = i - 1;
                        r_1 = xx(i_4);
                        r_2 = aleft(i, j);
                        r_3 = xx(i);
                        r_4 = right(i, j);
                          G4.draw_line(r_1, r_2, r_3, r_4);
                }else{
                          if((f > v && fnew[i - 1] >= v) || (f < v && fnew[i - 1] < v)) {
                                    i_4 = i - 1;
                                   r_1 = xx(i_4);
                                   r_2 = aleft(i, j);
                                   r_3 = top(i);
                                   r_4 = yy(j);
                            G4.draw_line(r_1, r_2, r_3, r_4);
                            r_1 = bot(i);
                            i_4 = j - 1;
                            r_2 = yy(i_4);
                            r_3 = xx(i);
                            r_4 = right(i, j);
                                  G4.draw_line(r_1, r_2, r_3, r_4);
                          }else{
                                  i_4 = i - 1;
                                  r_1 = xx(i_4);
                                  r_2 = aleft(i, j);
                                  r_3 = bot(i);
                                  i_5 = j - 1;
                                  r_4 = yy(i_5);
                                  G4.draw_line(r_1, r_2, r_3, r_4);
                                  r_1 = top(i);
                                  r_2 = yy(j);
                                  r_3 = xx(i);
                                  r_4 = right(i, j);
                                  G4.draw_line(r_1, r_2, r_3, r_4);
                }}
                break;}
          case  8:
          case  9:  {
                i_4 = i - 1;
                r_1 = xx(i_4);
                r_2 = aleft(i, j);
                r_3 = top(i);
                r_4 = yy(j);
                G4.draw_line(r_1, r_2, r_3, r_4);
                break;}
          }}}
   i_2 = numx;
   for(i = 1; i <= i_2; ++i)
      fold[i - 1] = fnew[i - 1];
  }
} /* cntr */

double xx(int i){
  double ret_val;
  ret_val = xlow + delx * (i - 1);
  return ret_val;
} /* xx */
double yy(int j){
  double ret_val;
  ret_val = ylow + dely * (j - 1);
  return ret_val;
} /* yy */
double top(int i){
  double ret_val;
  ret_val = delx * (i - 2 + ainter(fnew[i - 2], fnew[i - 1])) + xlow;
  return ret_val;
} /* top */
double bot(int i){
  double ret_val;
  ret_val = delx * (i - 2 + ainter(fold[i - 2], fold[i - 1])) + xlow;
  return ret_val;
} /* bot */
double aleft(int i, int j){
  double ret_val;
  ret_val = dely * (j - 2 + ainter(fold[i - 2], fnew[i - 2])) + ylow;
  return ret_val;
} /* aleft */
double right(int i, int j){
  double ret_val;
  ret_val = dely * (j - 2 + ainter(fold[i - 1], fnew[i - 1]))+ ylow;
  return ret_val;
} /* right */
double ainter(double a, double b){
  double ret_val;
  ret_val = (v - a) / (b - a);
  return ret_val;
} /* ainter */
double DeltaT_geom(double x[]){
  double x_new[]=new double[2], y_new[]=new double[2],Y[]=new double[2];
  double detA, DeltaT;

  x_new[0] = G4.F.A1 * x[0] + G4.F.D  * x[1];
  x_new[1] = G4.F.D  * x[0] + G4.F.A2 * x[1];

  detA = Math.sqrt(1.0 - Double.parseDouble(G4.F.Par[mod][3][3])) - (Double.parseDouble(G4.F.Par[mod][2][3])* Double.parseDouble(G4.F.Par[mod][2][3]));

  y_new[0] = (  G4.F.A2 * Y[0] - G4.F.D  * Y[1]) / detA;
  y_new[1] = (- G4.F.D  * Y[0] + G4.F.A1 * Y[1]) / detA;

  DeltaT  = x_new[0] * x[0]     + x_new[1] * x[1];
  DeltaT -= x_new[0] * y_new[0] + x_new[1] * y_new[1];
  DeltaT -= Y[0]     * x[0]     + Y[1]     * x[1];
  DeltaT += y_new[0] * Y[0]     + y_new[1] * Y[1];
  DeltaT /= 2.0;
  return DeltaT;
}

double Potential(double x, double y){

  double hs, x_rot[]=new double[2], Psi = 0.0, DeltaT, s2, radio, rad0, rad2, MDipol, MQuadrupol, RoT,Epsilon1=0,Epsilon2=0;
  if(mod==4){
  Epsilon1 = 1.0 - Double.parseDouble(G4.F.Par[mod][8][3]);
  Epsilon2 = 1.0 + Double.parseDouble(G4.F.Par[mod][8][3]);}

  x_rot[0] =   x * G4.cs + y * G4.ss;
  x_rot[1] = - x * G4.ss + y * G4.cs;

  radio = x_rot[0] * x_rot[0] + x_rot[1] * x_rot[1];
  rad2  = (x_rot[0] * x_rot[0] + x_rot[1] * x_rot[1]) / G4.F.R_E2;
  rad0  = Math.sqrt(rad2);

  if(mod==4 && rad2 == 0.0) {
    radio += Epsilon;
    rad2  += Epsilon;
    rad0  = Math.sqrt(rad2);
  }
  switch(mod) {
  case 0:
    Psi = Math.log(rad2) / 2.0;
    break;
  case 1:
    if(Double.parseDouble(G4.F.Par[mod][6][3]) != 0.0) {
      Psi = Math.pow(rad2, (Double.parseDouble(G4.F.Par[mod][6][3]) / 2.0)) / Double.parseDouble(G4.F.Par[mod][6][3]);
    } else {
      Psi = Math.log(rad2) / 2.0;
    }
    break;
  case 2:
    s2   = G4.F.xc2 + rad2;
    Psi  = Math.sqrt(s2) - G4.F.xc + G4.F.xc * Math.log((2.0 * G4.F.xc)/(G4.F.xc + Math.sqrt(s2)));
    Psi *= Double.parseDouble(G4.F.Par[mod][6][3]);
    break;
  case 3:
    Psi = 0.0;
    break;
  case 4:
    s2 = G4.F.xc2 + (Epsilon1 * x_rot[0] * x_rot[0] + Epsilon2 * x_rot[1] * x_rot[1]) / G4.F.R_E2;
    if(Double.parseDouble(G4.F.Par[mod][9][3]) != 0.0) {
      Psi  = (Math.pow((s2 / G4.F.xc2), Double.parseDouble(G4.F.Par[mod][9][3])) - 1.0) / (2.0 * Double.parseDouble(G4.F.Par[mod][9][3]));
      Psi *= Double.parseDouble(G4.F.Par[mod][6][3]);
    }else{
      Psi = Double.parseDouble(G4.F.Par[mod][6][3]) * Math.log(s2 / G4.F.xc2) / 2.0;
    }
    break;
  case 5:
    hs = (rad0 - XINC) / ((double) Nint);
    Psi = - Double.parseDouble(G4.F.Par[mod][6][3]) * Simpson(XINC, rad0, hs, (int) Nint);
    break;
  case 6:
    Psi = 0.0;
    break;
  case 7:
    hs = (rad2 - XINC) / ((double) Nint);
    Psi = 2.0 * Double.parseDouble(G4.F.Par[mod][6][3]) * (Simpson(XINC, rad2, hs, (int) Nint) - Math.log(1+rad2));
    break;
  case 8:
    Psi = 0.0;
    break;
  case 9:
    hs = (rad2 - XINC) / ((double) Nint);
    Psi = 2.0 * Double.parseDouble(G4.F.Par[mod][6][3]) * Simpson(XINC, rad2, hs, (int) Nint) / (Double.parseDouble(G4.F.Par[mod][7][3]) * Double.parseDouble(G4.F.Par[mod][7][3]));
    break;
  case 10:
    MDipol     = (Double.parseDouble(G4.F.Par[mod][0][3]) * (Double.parseDouble(G4.F.Par[mod][7][3]) * x_rot[0] + Double.parseDouble(G4.F.Par[mod][8][3]) * x_rot[1])) / radio;
    MQuadrupol = (G4.F.R_E2 * (Double.parseDouble(G4.F.Par[mod][9][3]) * x_rot[0] * x_rot[0] + 2.0 * Double.parseDouble(G4.F.Par[mod][10][3]) * x_rot[0] * x_rot[1] + Double.parseDouble(G4.F.Par[mod][11][3]) * x_rot[1] * x_rot[1])) / Math.sqrt(radio);
    Psi = Double.parseDouble(G4.F.Par[mod][6][3])* Math.log(rad2) / 2.0 - (MDipol + MQuadrupol);
    break;
  case 11:
    RoT = (Double.parseDouble(G4.F.Par[mod][6][3]) * x_rot[0] - Double.parseDouble(G4.F.Par[mod][7][3]) * x_rot[1]) / Double.parseDouble(G4.F.Par[mod][0][3]);
    Psi = Math.log(rad2) / 2.0 + 4.0 * RoT / rad2;
    break;
  case 12:
    Psi = 0.0;
    break;
  case 13:
    Psi = 0.0;
    break;
  }
  DeltaT = DeltaT_geom(x_rot) - G4.F.R_E2 * Psi;
  return(DeltaT);
}
double maximum(double a, double b){
        if(a>=b)
                return a;
        return b;
}
void root_finder(double swept, double x[], int color){
  int i, ir = 0;
  double x_init[]=new double[2], dxi = swept, dxf, dyf, xf  = BOUND;
  switch((int)swept) {
  case 1:
    for(dxf = - xf; dxf <= xf; dxf += dxi) {
      x_init[0] = dxf;
      x_init[1] = 0.0;
      roots(ir, color, 1);
      ir += 1;
    }
    for(dyf = - xf; dyf <= xf; dyf += dxi) {
      x_init[0] = 0.0;
      x_init[1] = dyf;
      roots(ir, color, 1);
      ir += 1;
    }
    break;
  case 2:
    for(dxf = - xf; dxf <= xf; dxf += dxi) {
      for(dyf = - xf; dyf <= xf; dyf += dxi) {
        x_init[0] = dxf;
        x_init[1] = dyf;
        roots(ir, color, 1);
        ir += 1;
      }
    }
    break;
  case 3:
    for(i = 0; i < Number_of_roots; i++)
      roots2(Xr[i][0], Xr[i][1], i, 4);
    break;
  default: break;
  }
}
void root_finder2(double swept, double x[], int color, double rad){
  int ir = 0;
  double x_init[]=new double[2], dxi = swept, phi, dxf, dyf, r = Double.parseDouble(G4.F.Par[mod][5][3]),xf  = BOUND, Npi = 2.0 * Math.PI,z1 = G4.X,z2 = G4.Y;
  for(phi = 0; phi < Npi; phi = phi + 0.5) {
    pars[0] = r * Math.cos(phi) + z1;
    pars[1] = r * Math.sin(phi) + z2;

    for(dxf = - xf; dxf <= xf; dxf += dxi) {
      for(dyf = - xf; dyf <= xf; dyf += dxi) {
        x_init[0] = dxf;
        x_init[1] = dyf;
        roots4(x_init, ir, color, rad, pars);
        ir += 1;
      }
    }
  }
}
void roots2(double xinit, double yinit, int j, int color){
  double fvec[]=new double[Ne],fnorm1, fnorm2, wa[]=new double[Nb], tol=1.0e-10, sqroot,x[]=new double[Ne];
  int info=0, nfev,i,lwa=Nb;
  for(i = 0; i < Ne; i++)
    fvec[i] = 0.0;
  for(i = 0; i < Nb; i++)
    wa[i] = 0.0;
  fnorm1 = 0.0;
  x[0] = xinit;
  x[1] = yinit;
  for(i = 0; i < Ne; i++) {
    funct(x[0],x[1]);
    fvec[0] = fnct1;
        fvec[1] = fnct2;
        ++nfcall1;
    fnorm1 = maximum(fnorm1, Math.abs(fvec[i]));
  }
  nfcall1 = 0;
  brent(Ne,tol, info);
  nfev = nfcall1 / Ne;
  fnorm2 = 0.0;
  for(i = 0; i < Ne; i++) {
    funct(x[0],x[1]);
    fvec[0] = fnct1;
        fvec[1] = fnct2;
        ++nfcall1;
    fnorm2 = maximum(fnorm2, Math.abs(fvec[i]));
  }
  sqroot = Math.sqrt(fvec[0] * fvec[0] + fvec[1] * fvec[1]);
  if(sqroot <= tol) {
    G4.draw_point(x[0], x[1], 5, color,1);
    root_x[j] = x[0];
    root_y[j] = x[1];
  }
}
void roots3(double x[], int j, int color, double rad){
  double fvec[]=new double[Ne],fnorm1, fnorm2, wa[]=new double[Nb], tol=1.0e-10, sqroot;
  int info=0, nfev,i,lwa=Nb;
  for(i = 0; i < Ne; i++)
    fvec[i] = 0.0;
  for(i = 0; i < Nb; i++)
    wa[i] = 0.0;
  fnorm1 = 0.0;
  for(i = 0; i < Ne; i++) {
    funct(x[0],x[1]);
        fvec[0] = fnct1;
        fvec[1] = fnct2;
        ++nfcall1;
    fnorm1 = maximum(fnorm1, Math.abs(fvec[i]));
  }
  nfcall1 = 0;
  brent(Ne, tol, info);
  nfev = nfcall1 / Ne;
  fnorm2 = 0.0;
  for(i = 0; i < Ne; i++) {
    fvec[0] = fnct1;
        fvec[1] = fnct2;
        ++nfcall1;
    fnorm2 = maximum(fnorm2, Math.abs(fvec[i]));
  }
  sqroot = Math.sqrt(fvec[0] * fvec[0] + fvec[1] * fvec[1]);
  if(sqroot <= tol) {
    G4.draw_point(x[0], x[1], (float)rad, color,1);
    root_x[j] = x[0];
    root_y[j] = x[1];
  }
}
void roots4(double x[], int j, int color, double rad,double v[]){
  double fvec[]=new double[Ne],fnorm1, fnorm2, wa[]=new double[Nb], tol=1.0e-10, sqroot;
  int info=0, nfev,i,lwa=Nb;
  for(i = 0; i < Ne; i++)
    fvec[i] = 0.0;
  for(i = 0; i < Nb; i++)
    wa[i] = 0.0;
  fnorm1 = 0.0;
  for(i = 0; i < Ne; i++) {
    funct(x[0],x[1]);
    fvec[0] = fnct1;
        fvec[1] = fnct2;
        ++nfcall1;
    fnorm1 = maximum(fnorm1, Math.abs(fvec[i]));
  }
  nfcall1 = 0;
  brent(Ne, tol, info);
  nfev = nfcall1 / Ne;
  fnorm2 = 0.0;
  for(i = 0; i < Ne; i++) {
    fvec[0] = fnct1;
        fvec[1] = fnct2;
        ++nfcall1;
    fnorm2 = maximum(fnorm2, Math.abs(fvec[i]));
  }
  sqroot = Math.sqrt(fvec[0] * fvec[0] + fvec[1] * fvec[1]);
  if(sqroot <= tol)
    G4.draw_point(x[0], x[1], (float)rad, color, 1);
}
double signum(double x1, double x2){
  double csignum = 1.0;
    if((x1 > 0.0 || x1 == 0.0) && x2 > 0) {
      csignum = 1.0;} else if((x1 < 0.0 || x1 == 0.0) && x2 < 0) {
      csignum = - 1.0;}
    return(csignum);
}
static double x[]=new double[2];
void roots(int j, int color, int plot){
  double fvec[]=new double[Ne],fnorm1=0, fnorm2=0, tol=1.0e-10, sqroot,xre[]=new double[2];
  int info=0, nfev,i;
  for(i = 0; i < Ne; i++)
    fvec[i] = 0.0;
  /*for(i = 0; i < Nb; i++)
    wa[i] = 0.0;
  //for(i = 0; i < Ne; i++) {
    funct(G4.x_init[0],G4.x_init[0]);
        fvec[0] = fnct1;
        fvec[1] = fnct2;
        ++nfcall1;
    //fnorm1 = maximum(fnorm1, Math.abs(fvec[i]));
  //}*/
  nfcall1 = 0;
  brent(Ne, tol, info);
  nfev = nfcall1 / Ne;
  //for(i = 0; i < Ne; i++) {
        double xi0=x[0],xi1=x[1];
        funct(xi0,xi1);
        fvec[0] = fnct1;
        fvec[1] = fnct2;
        ++nfcall1;
        //fnorm2 = maximum(fnorm2, Math.abs(fvec[i]));
  //}
  sqroot = Math.sqrt(((fvec[0] * fvec[0]) + (fvec[1] * fvec[1])));
  if(sqroot <= tol) {
    G4.draw_point(x[0], x[1], 5, color,plot);
    root_x[j] = x[0];
    root_y[j] = x[1];
  }
}
int brent(int n, double tol, int info){
  double emax, ftol, temp, xtol;
  int nfev=0, mopt=0, i, maxfev;
  info = 0;
  if (n <= 0 || tol < 0 || Nb <(n*(n + 3)))
    return 0;
  emax = 0;
  for(i = 0; i < n; i++) {
    temp = Math.log(((i + 1)/(n + 2 * i + 1)));
    if(temp < emax) {
            maxfev = 50 * (n + 3);
            brentm(n, tol, tol, maxfev, mopt);
            return 0;
    }
    mopt = i;
    emax = temp;
  }
  return 0;
}
void brentm(int n, double ftol,double xtol, int maxfev, int mopt){
        double zero  =  0, p05   =  0.05, scale = 10.0, temp, h, delta=0, difit=0, fnorm=0, xnorm=0, difit1, fnorm1, epsmch= 2.2204460492503131e-16, sknorm, eta, eps=0, fky, fkz;
        double d,q[]=new double[3*n],sigma[]=new double[n], wa1[]=new double[n], wa2[]=new double[2*n],fvec[]=new double[Ne];
        boolean Conta=true;
        int conv,nier6=0, nier7=0, nier8=0,i, j, k, m, iflag=0,nsing, nfcall=0,ldq=n,info=0,nfev=0;
        for(i = 0; i <(3*n); i++){
                q[i] = 0;
                    if(i<n){ wa1[i]  = 0;
                                     sigma[i]= 0;}
                    if(i<(2*n))wa2[i]= 0;}
        if((n <= 0) || (ftol < zero) || (xtol < zero) || (maxfev <= 0) || (mopt < 0) || (ldq < n));
        else{
                  nier6 = -1;
                  nier7 = -1;
                  nier8 =  0;
                  for(i = 0; i < n; i++)
                    xnorm = maximum(xnorm, Math.abs(G4.x_init[i]));
                  eps   = Math.sqrt(epsmch);
                  delta = scale * xnorm;
                  if(xnorm == zero)
                    delta = scale;
        }
        x[0]=G4.x_init[0];
        x[1]=G4.x_init[1];
        L20:while(Conta){
                  nsing = n;
                  fnorm1 = fnorm;
                  difit1 = difit;
                  fnorm  = zero;
                  h = eps * xnorm;
                  if(h == zero)
                          h = eps;
                  for(j = 0; j < n; j++) {
                    for(i = 0; i < n; i++)
                           q[i + j * ldq] = zero;
                    q[j + j * ldq] = h;
                    wa1[j] = x[j];
                  }
                  L21:for(k = 0; k < n; k++) {
                    iflag = k;
                    double xi00=wa1[0],xi11=wa1[1];
                    funct(xi00,xi11);
                    fvec[0] = fnct1;
                    fvec[1] = fnct2;
                    nfcall1++;
                    fky = fvec[k];
                    nfcall++;
                    nfev = nfcall / n;
                    if(iflag < 0)
                      break L20;
                    fnorm = maximum(fnorm, Math.abs(fky));
                    for(j = k; j < n; j++) {
                              for(i = 0; i < n; i++)
                                      wa2[i] = wa1[i] + q[i + j * ldq];
                              double xi0=wa2[0],xi1=wa2[1];
                              funct(xi0,xi1);
                              fvec[0] = fnct1;
                              fvec[1] = fnct2;
                              nfcall1++;
                              fkz = fvec[k];
                              nfcall++;
                              nfev = nfcall / n;
                              if(iflag < 0)
                                break L20;
                              sigma[j] = fkz - fky;
                    }
                    fvec[k] = fky;
                    eta = zero;
                    for(i = k; i < n; i++){
                            double sii=sigma[i];
                            eta = maximum(eta, Math.abs(sii));
                            }
                    if(eta == zero)
                            continue L21;
                    nsing--;
                    sknorm = zero;
                    for(i = k; i < n; i++) {
                            sigma[i] /= eta;
                            sknorm   += sigma[i] * sigma[i];
                    }
                    sknorm = Math.sqrt(sknorm);
                    if(sigma[k] < zero)
                            sknorm = (sknorm)*(-1);
                    sigma[k] += sknorm;
                    for(i = 0; i < n; i++)
                              wa2[i] = zero;
                    for(j = k; j < n; j++) {
                              temp = sigma[j];
                              for(i = 0; i < n; i++)
                                wa2[i] += temp * q[i + j * ldq];
                    }
                    for(j = k; j < n; j++) {
                              temp = sigma[j] / (sknorm * sigma[k]);
                              for(i = 0; i < n; i++)
                                q[i + j * ldq] -= temp * wa2[i];
                    }
                    sigma[k] = sknorm * eta;
                    temp = fky / sigma[k];
                    if(h * Math.abs(temp) > delta) {
                              d    = delta / h;
                              temp = signum(d, temp);
                    }
                    for(i = 0; i < n; i++)
                              wa1[i] += temp * q[i + k * ldq];
                  }
                  xnorm = zero;
                  difit = zero;
                  for(i = 0; i < n; i++) {
                    double xii=x[i],wo=wa1[i];
                    xnorm = maximum(xnorm, Math.abs(wo));
                    difit = maximum(difit, Math.abs(xii - wo));
                    x[i] = wa1[i];
                  }
                  delta = maximum(delta, scale * xnorm);
                  boolean conv1 = (fnorm < fnorm1 && difit < difit1 && nsing==0);
                  if(conv1) conv=1;
                  else conv=0;
                  ++nier6;
                  ++nier7;
                  ++nier8;
                  if(conv==1)
                    nier6 = 0;
                  if((fnorm < fnorm1) || (difit < difit1))
                    nier7 = 0;
                  if(difit > eps * xnorm)
                    nier8 = 0;
                  if(fnorm <= ftol)
                    info = 1;
                  if((difit <= xtol * xnorm) && (conv==1))
                    info = 2;
                  if(fnorm <= ftol && info == 2)
                    info = 3;
                  if(info != 0)
                    break L20;
                  if(nfev >= maxfev)
                    info = 4;
                  if(nsing == n)
                    info = 5;
                  if(nier6 == 5)
                    info = 6;
                  if(nier7 == 3)
                    info = 7;
                  if(nier8 == 4)
                    info = 8;
                  if(info != 0)
                    break L20;
                  if((conv==0) || (difit > p05 * xnorm) || (mopt == 1))
                    continue L20;
                  for(m = 1; m < mopt; m++) {
                    fnorm1 = fnorm;
                    fnorm = zero;
                    for(k = 0; k < n; k++) {
                              iflag = k;
                              double xi0=wa1[0],xi1=wa1[1];
                              funct(xi0,xi1);
                              fvec[0] = fnct1;
                              fvec[1] = fnct2;
                              nfcall1++;
                              fky = fvec[k];
                              nfcall++;
                              nfev = nfcall / n;
                              if(iflag < 0)
                                break L20;
                              fnorm = maximum(fnorm, Math.abs(fky));
                              if(fnorm < fnorm1);
                              else{
                                      fnorm = fnorm1;
                                      continue L20;
                              }
                              temp = fky / sigma[k];
                              for(i = 0; i < n; i++)
                                wa1[i] += temp * q[i + k * ldq];
                    }
                    xnorm = zero;
                    difit = zero;
                    for(i = 0; i < n; i++) {
                              double xii=x[i],wo=wa1[i];
                              xnorm = maximum(xnorm, Math.abs(wo));
                              difit = maximum(difit, Math.abs(xii - wo));
                              x[i] = wa1[i];
                    }
                    if(fnorm <= ftol)
                              info = 1;
                    if(difit <= xtol * xnorm)
                              info = 2;
                    if(fnorm <= ftol && info == 2)
                              info = 3;
                    if(nfev >= maxfev && info == 0)
                              info = 4;
                    if(info != 0)
                              break L20;
                  }
        }
        if(iflag < 0)
            info = iflag;
}
double Simpson(double a, double b, double h, int n){
  int i, ls, three = 3;
  double s = 0.0, sum = 0.0, w, x;

  if((2 * ((int) (n / 2))) == n) {
    ls = 0;
  } else {
    ls = 3;
    for(i = 0; i <= three; i++) {
      x = a + h * ((double) i);
      w = 3.0;
      if(i == 0 || i == three)
                w = 1.0;
      sum += w * TFunc(x);
    }
    sum += (3.0 * h * sum) / 8.0;
    if(n == 3) {
      return(0);
    }
  }

  for(i = 0; i <= (n - ls); i++) {
    x = a + h * ((double) (i + ls));
    w = 2.0;

    if((2 * ((int) (i / 2)) + 1) == i)
            w = 4.0;

    if(i == 0 || i == n - ls)
            w = 1.0;
    s += w * TFunc(x);
  }
  s = sum + (h * s) / 3.0;
  return(s);
}

double TFunc(double x){
  double fx = 0.0;
  switch(mod) {
  case 5:
    fx = Math.log(1+(x * x)) / x;
    break;
  case 7:
    fx = Math.log(1+x) / x;
    break;
  case 9:
    fx = (1.0 - Math.exp(- Double.parseDouble(G4.F.Par[mod][7][3]) * x) * (1.0 +  x)) / x;
    break;
  }
  return(fx);
}
double funct(double x, double y){
  double Funct2, xbar0 = 0.0, xbar1 = 0.0, xl = 0.0, yl = 0.0;
  xbar0 =   (x - xl) * G4.cs + (y - yl) * G4.ss;
  xbar1 =   (xl - x) * G4.ss + (y - yl) * G4.cs;

  G4.F.lens_equation(xbar0, xbar1);

  fnct1 = G4.X - G4.F.A1 * xbar0 - G4.F.D * xbar1 + G4.F.alpha1;
  fnct2 = G4.Y - G4.F.A2 * xbar1 - G4.F.D * xbar0 + G4.F.alpha2;
  Funct2 = (fnct1 * fnct1 + fnct2 * fnct2) / 2.0;
  return(Funct2);
} /* funct */
void draw_contour_td(){
  int i, j, kc = 50;
  double x, y, d[]=new double[Nd];

  for(i = 0; i < kc; ++i) {
    for(j = 0; j < kc; ++j) {
      x = ((double) i);
      y = ((double) j);

      d[i + j * Np] = Potential(x, y);
    }
  }
  cntr(c_M, c_N, c_10, c_12, c_10, c_12, d, c_3, c_0, c_b11, c_0);
}
public void draw_contour(){
  int i, j, kc = 50;
  double x, y, d[]=new double[Nd];

  for(i = 0; i < kc; ++i) {
    for(j = 0; j < kc; ++j) {
      x = ((double) i);
      y = ((double) j);

      d[i + j * Np] = funct(x, y);
    }
  }
  cntr(c_M, c_N, c_10, c_12, c_10, c_12, d, c_3, c_0, c_b11, c_0);
}
}

